<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>Turing Machine To Unrestricted Grammar</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.0  (Linux)">
	<META NAME="CREATED" CONTENT="20070626;12010500">
	<META NAME="CHANGED" CONTENT="20080522;12101800">
	<STYLE>
	<!--
		@page { size: 8.5in 11in }
	-->
	</STYLE>
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Converting Turing
Machine to an Unrestricted Grammar</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#introduction"><U>Introduction</U></A><BR><A HREF="#convert"><U>Converting
to an Unrestricted Grammar</U></A><BR><A HREF="#Export and Parse|outline">Export
and Parse</A></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="introduction"></A>
Introduction</H2>
<P STYLE="margin-bottom: 0in">Any Turing machine can be converted to
an unrestricted grammar. 
</P>
<P STYLE="margin-bottom: 0in">JFLAP defines an unrestricted grammar
as a grammar that is similar to a context-free grammar (CFG), except
that the left side of a production may contain any nonempty string of
terminals and variables, rather than just a single variable. In an
unrestricted grammar, the left side of a production is matched, which
may be multiple symbols, and replaced by the corresponding right hand
side.</P>
<P STYLE="margin-bottom: 0in">This conversion implements the
algorithm in the book “An Introduction to Formal Languages and
Automata 4<SUP>th</SUP> Edition” by Peter Linz. The algorithm can
be founded on page 283-285.</P>
<P STYLE="margin-bottom: 0in">There are 3 major steps that the
algorithm follows in order to convert the Turing machine to an
unrestrcted grammar. The first step is applying the basic rules from
the start variable. It allows the grammar to generate an encoded
version of any string q0w with an arbitrary number of leading and
trailing blanks. The second step is applying generating the
production for each transition of Turing machine. The last step is
applying additional rules to our productions if we enter one of final
states of TM, so we can derive terminals.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="convert"></A>
Converting to an Unrestricted Grammar</H2>
<P>We will now convert the TM into an unrestricted grammar. First,
open up the Turing Machine window and load the file
<A HREF="verysimple_TM.jff">verysimple_TM.jff</A>. 
</P>
<P>Click on the <B>Convert → Convert to Unrestricted Grammar</B>
menu option, and the following screen should appear :</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_0.png" NAME="Graphic2" ALIGN=MIDDLE WIDTH=852 HEIGHT=659 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">This is a very simple Turing
machine that accepts any language that has one or more “a”s. Just
like other conversion windows, you can click the <B>What's Left?</B>
button to view what states or transitions remain to be converted.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, let's produce our first
productions for our new grammar (the first step of algorithm). By
default, there are going to be 3 productions that are going to be
produced for every TM that is going to be converted. These three
rules are <BR>“S-&gt;V(==)S, S-&gt;SV(==), S-&gt;T”, where S is
the start variable. In addition there are going to be 2 additional
rules “T-&gt;TV(aa), T-&gt;V(a0a)”, in which “a” refers to
for all readable strings in the tape. The result of productions
generated by the first step can be viewed by clicking initial state
q0. Note that “=” refers to the blank tape symbol in the Turing
machine. After clicking the state q0, your window would look like
this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_1.png" NAME="Graphic5" ALIGN=MIDDLE WIDTH=852 HEIGHT=659 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, let's move on to the
second step of algorithm and examine our first transition from q0 to
q1. The transition is (q0, a) =&gt; (q1, a, R). By following the
algorithm, we are going to place production V(x0a)V(yz) →
V(xa)V(y1z), where x, y is all elements of input alphabet+blank
symbol and z is all elements of the tape alphabet. Since we only have
“a” in our input alphabet our x and y is going to be “a”. “z”
can be either “a” or “=” (blank). Also, since q1 is final
state, we have to apply the last step of algorithm . We apply the
special rule V(a1a) → a and yV(xz) → <FONT FACE="Times New Roman, serif">a,
where x and y are all the input alphabet + blank symbol (=) and z is
all of our tape alphabets. By doing so, we can generate terminals on
the right hand side of productions. After applying all of these
rules, our grammar window would look like :</FONT></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_2.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=852 HEIGHT=659 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">After either clicking our
last transition in q1 or using <B>Show All</B> button, we can finish
our conversion.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_3.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=852 HEIGHT=659 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Export and Parse|outline"></A>
Export and Parse</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Let's now export this
converted grammar. You can click on <B>Export</B> button to export
this grammar. After exporting the grammar, your window would look
like this :</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_4.png" NAME="Graphic7" ALIGN=MIDDLE WIDTH=820 HEIGHT=690 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now let's try to parse this
unrestricted grammar, note that V(aa) is actually refers to one
variable. Click on <B>Input </B>and <B>Parser for Converted Grammar
from TM</B>. You will see very similar grammar parse pane from brute
force parsing. In this parser, all the variables such as V(aa) is
trimmed into regular variable like “A” or “B”, so the parsing
can occur. This trimming procedure is done internally in the parser.
In the input, type in string “aa”. You can see that the this
string is accepted by the language as expected. Click on <B>STEP</B>
buttons several times to see how we derive this string. You can
either view the derivation in Noninverted tree or Derivation table.
Your result should look like one of these windows. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>NOTE</B>: The JFLAP
Parser recognizes this special notation in the grammar. It converts
varaibles such as V(aa) into normal variables like “A” in the
background to facilitate the parsing.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>WARNING:</B> This only
works with very small examples since the conversion is exponential.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_5.png" NAME="Graphic9" ALIGN=MIDDLE WIDTH=820 HEIGHT=690 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_6.png" NAME="Graphic9" ALIGN=MIDDLE WIDTH=820 HEIGHT=690 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now let's try to input
“aaaaaaaa” (8 a's). The parser quickly accepts the language, but
note that there are 271 nodes generated for such a simple string.
This reveals that the parser is going to have really hard time
parsing other complicated grammar such as a^nb^nc^n. As Turing
machine gets more complicated, the parsing of converted grammar would
get more difficult and almost impossible. Although the converted
grammar might not be useful in actually checking the string, it
proves that TM can be converted to unrestricted grammar.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>NOTE:</B> You can also
use user control parser to derive the string manually.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Another example of
converting TM to unrestricted grammar is shown in below windows. You
can load the file <A HREF="anothersimple_TM.jff">anothersimple_TM.jff</A>
to load this example. Note that it generated 21578 nodes to just to
accept simple string “ab”.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_7.png" NAME="Graphic9" ALIGN=MIDDLE WIDTH=823 HEIGHT=692 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_8.png" NAME="Graphic11" ALIGN=MIDDLE WIDTH=826 HEIGHT=695 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/image_9.png" NAME="Graphic11" ALIGN=MIDDLE WIDTH=826 HEIGHT=695 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on converting Turing machine into an unrestricted grammar.
Thanks for reading!</B></P>
</BODY>
</HTML>